/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_CONVERTMHLOQUANTTOINT
#define GEN_PASS_DECL_CONVERTTFQUANTOPSTOMHLO
#define GEN_PASS_DECL_CONVERTTFQUANTTYPES
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// ConvertMHLOQuantToInt
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_CONVERTMHLOQUANTTOINT
struct ConvertMHLOQuantToIntOptions {
  bool legalize_chlo_ = true;
};
#undef GEN_PASS_DECL_CONVERTMHLOQUANTTOINT
#endif // GEN_PASS_DECL_CONVERTMHLOQUANTTOINT
#ifdef GEN_PASS_DEF_CONVERTMHLOQUANTTOINT
namespace impl {

template <typename DerivedT>
class ConvertMHLOQuantToIntBase : public ::mlir::OperationPass<mlir::func::FuncOp> {
public:
  using Base = ConvertMHLOQuantToIntBase;

  ConvertMHLOQuantToIntBase() : ::mlir::OperationPass<mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  ConvertMHLOQuantToIntBase(const ConvertMHLOQuantToIntBase &other) : ::mlir::OperationPass<mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("convert-mhlo-quant-to-int");
  }
  ::llvm::StringRef getArgument() const override { return "convert-mhlo-quant-to-int"; }

  ::llvm::StringRef getDescription() const override { return "Convert from MHLO quantized ops to MHLO primitive ops."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ConvertMHLOQuantToInt");
  }
  ::llvm::StringRef getName() const override { return "ConvertMHLOQuantToInt"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<chlo::ChloDialect>();

  registry.insert<mhlo::MhloDialect>();

  registry.insert<quant::QuantizationDialect>();

  registry.insert<shape::ShapeDialect>();

  registry.insert<func::FuncDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ConvertMHLOQuantToIntBase<DerivedT>)

  ConvertMHLOQuantToIntBase(const ConvertMHLOQuantToIntOptions &options) : ConvertMHLOQuantToIntBase() {
    legalize_chlo_ = options.legalize_chlo_;
  }
protected:
  ::mlir::Pass::Option<bool> legalize_chlo_{*this, "legalize-chlo", ::llvm::cl::desc("Legalizes intermediate chlo ops to hlo"), ::llvm::cl::init(true)};
private:
};
} // namespace impl
#undef GEN_PASS_DEF_CONVERTMHLOQUANTTOINT
#endif // GEN_PASS_DEF_CONVERTMHLOQUANTTOINT

//===----------------------------------------------------------------------===//
// ConvertTFQuantOpsToMHLO
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_CONVERTTFQUANTOPSTOMHLO
#undef GEN_PASS_DECL_CONVERTTFQUANTOPSTOMHLO
#endif // GEN_PASS_DECL_CONVERTTFQUANTOPSTOMHLO
#ifdef GEN_PASS_DEF_CONVERTTFQUANTOPSTOMHLO
namespace impl {

template <typename DerivedT>
class ConvertTFQuantOpsToMHLOBase : public ::mlir::OperationPass<mlir::func::FuncOp> {
public:
  using Base = ConvertTFQuantOpsToMHLOBase;

  ConvertTFQuantOpsToMHLOBase() : ::mlir::OperationPass<mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  ConvertTFQuantOpsToMHLOBase(const ConvertTFQuantOpsToMHLOBase &other) : ::mlir::OperationPass<mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("quant-convert-tf-quant-ops-to-mhlo");
  }
  ::llvm::StringRef getArgument() const override { return "quant-convert-tf-quant-ops-to-mhlo"; }

  ::llvm::StringRef getDescription() const override { return "Convert TF Quant ops to MHLO quantizated ops."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ConvertTFQuantOpsToMHLO");
  }
  ::llvm::StringRef getName() const override { return "ConvertTFQuantOpsToMHLO"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<TF::TensorFlowDialect>();

  registry.insert<chlo::ChloDialect>();

  registry.insert<mhlo::MhloDialect>();

  registry.insert<tf_type::TFTypeDialect>();

  registry.insert<quant::QuantizationDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ConvertTFQuantOpsToMHLOBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_CONVERTTFQUANTOPSTOMHLO
#endif // GEN_PASS_DEF_CONVERTTFQUANTOPSTOMHLO

//===----------------------------------------------------------------------===//
// ConvertTFQuantTypes
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_CONVERTTFQUANTTYPES
#undef GEN_PASS_DECL_CONVERTTFQUANTTYPES
#endif // GEN_PASS_DECL_CONVERTTFQUANTTYPES
#ifdef GEN_PASS_DEF_CONVERTTFQUANTTYPES
namespace impl {

template <typename DerivedT>
class ConvertTFQuantTypesBase : public ::mlir::OperationPass<mlir::func::FuncOp> {
public:
  using Base = ConvertTFQuantTypesBase;

  ConvertTFQuantTypesBase() : ::mlir::OperationPass<mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  ConvertTFQuantTypesBase(const ConvertTFQuantTypesBase &other) : ::mlir::OperationPass<mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("convert-tf-quant-types");
  }
  ::llvm::StringRef getArgument() const override { return "convert-tf-quant-types"; }

  ::llvm::StringRef getDescription() const override { return "Replace TensorFlow qint types with int types."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ConvertTFQuantTypes");
  }
  ::llvm::StringRef getName() const override { return "ConvertTFQuantTypes"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<TF::TensorFlowDialect>();

  registry.insert<tf_type::TFTypeDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ConvertTFQuantTypesBase<DerivedT>)

protected:
private:
};
} // namespace impl
#undef GEN_PASS_DEF_CONVERTTFQUANTTYPES
#endif // GEN_PASS_DEF_CONVERTTFQUANTTYPES
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// ConvertMHLOQuantToInt Registration
//===----------------------------------------------------------------------===//

inline void registerConvertMHLOQuantToInt() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return mlir::stablehlo::createConvertMHLOQuantToIntPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerConvertMHLOQuantToIntPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return mlir::stablehlo::createConvertMHLOQuantToIntPass();
  });
}

//===----------------------------------------------------------------------===//
// ConvertTFQuantOpsToMHLO Registration
//===----------------------------------------------------------------------===//

inline void registerConvertTFQuantOpsToMHLO() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return mlir::stablehlo::CreateConvertTFQuantOpsToMHLOPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerConvertTFQuantOpsToMHLOPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return mlir::stablehlo::CreateConvertTFQuantOpsToMHLOPass();
  });
}

//===----------------------------------------------------------------------===//
// ConvertTFQuantTypes Registration
//===----------------------------------------------------------------------===//

inline void registerConvertTFQuantTypes() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return ::mlir::stablehlo::CreateConvertTFQuantTypesPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerConvertTFQuantTypesPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return ::mlir::stablehlo::CreateConvertTFQuantTypesPass();
  });
}

//===----------------------------------------------------------------------===//
// Bridge Registration
//===----------------------------------------------------------------------===//

inline void registerBridgePasses() {
  registerConvertMHLOQuantToInt();
  registerConvertTFQuantOpsToMHLO();
  registerConvertTFQuantTypes();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class ConvertMHLOQuantToIntBase : public ::mlir::OperationPass<mlir::func::FuncOp> {
public:
  using Base = ConvertMHLOQuantToIntBase;

  ConvertMHLOQuantToIntBase() : ::mlir::OperationPass<mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  ConvertMHLOQuantToIntBase(const ConvertMHLOQuantToIntBase &other) : ::mlir::OperationPass<mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("convert-mhlo-quant-to-int");
  }
  ::llvm::StringRef getArgument() const override { return "convert-mhlo-quant-to-int"; }

  ::llvm::StringRef getDescription() const override { return "Convert from MHLO quantized ops to MHLO primitive ops."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ConvertMHLOQuantToInt");
  }
  ::llvm::StringRef getName() const override { return "ConvertMHLOQuantToInt"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<chlo::ChloDialect>();

  registry.insert<mhlo::MhloDialect>();

  registry.insert<quant::QuantizationDialect>();

  registry.insert<shape::ShapeDialect>();

  registry.insert<func::FuncDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ConvertMHLOQuantToIntBase<DerivedT>)

protected:
  ::mlir::Pass::Option<bool> legalize_chlo_{*this, "legalize-chlo", ::llvm::cl::desc("Legalizes intermediate chlo ops to hlo"), ::llvm::cl::init(true)};
};

template <typename DerivedT>
class ConvertTFQuantOpsToMHLOBase : public ::mlir::OperationPass<mlir::func::FuncOp> {
public:
  using Base = ConvertTFQuantOpsToMHLOBase;

  ConvertTFQuantOpsToMHLOBase() : ::mlir::OperationPass<mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  ConvertTFQuantOpsToMHLOBase(const ConvertTFQuantOpsToMHLOBase &other) : ::mlir::OperationPass<mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("quant-convert-tf-quant-ops-to-mhlo");
  }
  ::llvm::StringRef getArgument() const override { return "quant-convert-tf-quant-ops-to-mhlo"; }

  ::llvm::StringRef getDescription() const override { return "Convert TF Quant ops to MHLO quantizated ops."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ConvertTFQuantOpsToMHLO");
  }
  ::llvm::StringRef getName() const override { return "ConvertTFQuantOpsToMHLO"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<TF::TensorFlowDialect>();

  registry.insert<chlo::ChloDialect>();

  registry.insert<mhlo::MhloDialect>();

  registry.insert<tf_type::TFTypeDialect>();

  registry.insert<quant::QuantizationDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ConvertTFQuantOpsToMHLOBase<DerivedT>)

protected:
};

template <typename DerivedT>
class ConvertTFQuantTypesBase : public ::mlir::OperationPass<mlir::func::FuncOp> {
public:
  using Base = ConvertTFQuantTypesBase;

  ConvertTFQuantTypesBase() : ::mlir::OperationPass<mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  ConvertTFQuantTypesBase(const ConvertTFQuantTypesBase &other) : ::mlir::OperationPass<mlir::func::FuncOp>(other) {}

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("convert-tf-quant-types");
  }
  ::llvm::StringRef getArgument() const override { return "convert-tf-quant-types"; }

  ::llvm::StringRef getDescription() const override { return "Replace TensorFlow qint types with int types."; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ConvertTFQuantTypes");
  }
  ::llvm::StringRef getName() const override { return "ConvertTFQuantTypes"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    
  registry.insert<TF::TensorFlowDialect>();

  registry.insert<tf_type::TFTypeDialect>();

  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ConvertTFQuantTypesBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
